package org.stm.projectbase.sys.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.stm.projectbase.sys.entity.StSysManage;
import org.stm.projectbase.sys.service.IStSysManageService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

/**
 * @Description: 系统管理
 * @Author: jeecg-boot
 * @Date: 2023-08-12
 * @Version: V1.0
 */
@Api(tags = "系统管理")
@RestController
@RequestMapping("/projectbase.sys/stSysManage")
@Slf4j
public class StSysManageController extends JeecgController<StSysManage, IStSysManageService> {
	@Autowired
	private IStSysManageService stSysManageService;

	/**
	 * 分页列表查询
	 *
	 * @param stSysManage
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	// @AutoLog(value = "系统管理-分页列表查询")
	@ApiOperation(value = "系统管理-分页列表查询", notes = "系统管理-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<StSysManage>> queryPageList(StSysManage stSysManage,
			@RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
			@RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req) {
		QueryWrapper<StSysManage> queryWrapper = QueryGenerator.initQueryWrapper(stSysManage, req.getParameterMap());
		Page<StSysManage> page = new Page<StSysManage>(pageNo, pageSize);
		if (stSysManage.getSysName() != null) {
			queryWrapper.like("sys_Name", "%" + stSysManage.getSysName() + "%");
		}
		if (stSysManage.getSysType() != null) {
			queryWrapper.eq("sys_Type", stSysManage.getSysType());
		}
		if (stSysManage.getStatus() != null) {
			queryWrapper.eq("status", stSysManage.getStatus());
		}
		queryWrapper.orderByDesc("created_Time");
		IPage<StSysManage> pageList = stSysManageService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	/**
	 * 添加
	 *
	 * @param stSysManage
	 * @return
	 */
	@AutoLog(value = "系统管理-添加")
	@ApiOperation(value = "系统管理-添加", notes = "系统管理-添加")
	@RequiresPermissions("projectbase.sys:st_sys_manage:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StSysManage stSysManage) {
		stSysManageService.save(stSysManage);
		return Result.OK("添加成功！");
	}

	/**
	 * 编辑
	 *
	 * @param stSysManage
	 * @return
	 */
	@AutoLog(value = "系统管理-编辑")
	@ApiOperation(value = "系统管理-编辑", notes = "系统管理-编辑")
	@RequiresPermissions("projectbase.sys:st_sys_manage:edit")
	@RequestMapping(value = "/edit", method = { RequestMethod.PUT, RequestMethod.POST })
	public Result<String> edit(@RequestBody StSysManage stSysManage) {
		stSysManageService.updateById(stSysManage);
		return Result.OK("编辑成功!");
	}

	/**
	 * 通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "系统管理-通过id删除")
	@ApiOperation(value = "系统管理-通过id删除", notes = "系统管理-通过id删除")
	@RequiresPermissions("projectbase.sys:st_sys_manage:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
		stSysManageService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 * 批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "系统管理-批量删除")
	@ApiOperation(value = "系统管理-批量删除", notes = "系统管理-批量删除")
	@RequiresPermissions("projectbase.sys:st_sys_manage:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
		this.stSysManageService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	// @AutoLog(value = "系统管理-通过id查询")
	@ApiOperation(value = "系统管理-通过id查询", notes = "系统管理-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<StSysManage> queryById(@RequestParam(name = "id", required = true) String id) {
		StSysManage stSysManage = stSysManageService.getById(id);
		if (stSysManage == null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stSysManage);
	}

	/**
	 * 导出excel
	 *
	 * @param request
	 * @param stSysManage
	 */
	@RequiresPermissions("projectbase.sys:st_sys_manage:exportXls")
	@RequestMapping(value = "/exportXls")
	public ModelAndView exportXls(HttpServletRequest request, StSysManage stSysManage) {
		return super.exportXls(request, stSysManage, StSysManage.class, "系统管理");
	}

	/**
	 * 通过excel导入数据
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequiresPermissions("projectbase.sys:st_sys_manage:importExcel")
	@RequestMapping(value = "/importExcel", method = RequestMethod.POST)
	public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
		return super.importExcel(request, response, StSysManage.class);
	}

}
